import static java.lang.Character.isLowerCase;
import static java.lang.Character.isUpperCase;
import static java.lang.Character.toLowerCase;
import java.util.*;
import java.util.stream.*;

public class ROT13  {
    int shift;
    Map<Character, Character> cypher;
    String alphabet = "abcdefghijklmnopqrstuvwxyz";

    ROT13(Character cs, Character cf) {
        shift = Math.abs((int)cs - (int)cf);
        setupHM();
    }

    ROT13() {
        shift = 13;
        setupHM();
    }

    public void setupHM() {
        cypher = new HashMap<>();
        for(Character c : alphabet.toCharArray()) {
            int offset = (int)c + shift > 122 ? (int)c - shift : (int)c  + shift;
            cypher.put(c, (char)offset);
        }
    }


    public String crypt(String text) throws UnsupportedOperationException {
        StringBuilder result = new StringBuilder();

        for(Character c : text.toCharArray()) {
            if (Character.isLetter(c)) {
                if (Character.isUpperCase(c)) {
                    result.append(Character.toUpperCase(cypher.get(Character.toLowerCase(c))));
                }
                else result.append(cypher.get(c));
            }
            else {
                result.append(c);
            }
        }
        return result.toString();
    }

    public String encrypt(String text) {
        return crypt(text);
    }

    public String decrypt(String text) {
        return crypt(text);
    }

    public static String rotate(String s, Character c) {
        String[] rotator = s.split("");
        StringBuilder result = new StringBuilder();

        for(int i = 0; i < rotator.length; i++) {
            result.append(rotator[(s.indexOf(c) + i) % rotator.length]);
        }
        return result.toString();
    }

}
